/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Menu server                                                            *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#define DO_either     0x00
#define DO_then       0x01
#define DO_else       0x02

#define VAR_retcode   0x00

#define ACTION_eq     0x00
#define ACTION_ne     0x01
#define ACTION_gt     0x02
#define ACTION_lt     0x03
#define ACTION_ge     0x04
#define ACTION_le     0x05



#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <mem.h>
#include "prog.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"

static char * near pascal Run_Option(struct _menu *menu,int opt,int ch,struct _msg *msg,int *ret_code,int *do_what);
static void near Process_If(struct _menu *menu,int opt,int *ret_code,int *do_what);

/* Global variable so that the '+' and '-' SysOp keys can adjust our       *
 * internal priv level, if necessary.                                      */

int okay;

int pascal Display_Options(char *name,struct _msg *msg)
{
  struct _menu menu;
  static char got_nullptr=FALSE; /* If we found a null pointer assignment... */

  int x,
      col,
      ret,
      ret_code,
      do_what,
      ch;

  char option,        /* The key our user picked */
       first_item,    /* If we've displayed the first option, only used for R)egular help */
       skipped_topline,/*If true, means we skipped displaying the top line,*
                       * since there was already a character waiting.      */
       menuinc,       /* If last key pressed was a wrong key */
       s_inmsgarea,   /* For saving the in-message-area value */
       s_infilearea,  /* For saving the in-file-area value */
       break_loop;    /* Used for getting out of for() loop while in       *
                       * the switch() statement.                           */

  char temp[BUFLEN],
       mname[MAX_MENUNAME],
       iread[IREADLEN],
       *last_mn,
       *p;

  last_mn=menuname;       /* Save old menuname */

  Initialize_Menu(&menu);

  rst_offset=-1L;

  strncpy(mname,name,MAX_MENUNAME-1);
  mname[MAX_MENUNAME-1]='\0';

  menuname=mname;

  s_inmsgarea=inmsgarea;
  s_infilearea=infilearea;
  entry=ENTRY_true;

MenuBegin:

  ret_code=0;
  okay=TRUE;
  menuhelp=usr.help;
  menuinc=FALSE;

  if (brk_trapped || mdm_halt())
  {
    brk_trapped=0;
    mdm_dump(DUMP_all);
  }

  while (1)
  {
    if (!got_nullptr && nullptr())
    {
      logit(">!Null ptr/%s. PLEASE REPORT BUG TO AUTHOR!",mname);
      got_nullptr=TRUE;
      Got_A_Null_Pointer();
    }

    Check_Dirty(&menu,iread);

    x=TRUE;

    switch(menu.header)
    {
      case HEADER_message:
        x=Header_Message(entry);
        break;

      case HEADER_file:
        x=Header_File(entry);
        break;

      case HEADER_change:
        x=Header_Change(entry);
        break;

      case HEADER_chat:
        x=Header_Chat(entry);
        break;

      case HEADER_none:
        x=Header_None(entry);
        break;
    }

    /* If some sort of error happened while doing the header, get out! */

    if (!x)
    {
      ret=-1;
      goto BackToCaller;
    }

    if (menu.headfile && (entry==ENTRY_true || entry==ENTRY_nocheck ||
                          entry==ENTRY_nochecke))
      if (Display_File(DISPLAY_hotmenu | DISPLAY_menuhelp,NULL,menu.headfile)==-1)
        logit(cantfind,menu.headfile);


    Check_Dirty(&menu,iread);


    strupr(glob_iread=iread);
    
    /* If we have a file to display, and user doesn't want it turned off */

    if (menu.dspfile)
    {
      if (isnl(linebuf))
      {
        if (Display_File(DISPLAY_hotmenu | DISPLAY_menuhelp,NULL,menu.dspfile)==-1)
          logit(cantfind,menu.dspfile);

        if (menu.hot_colour != -1)
        {
          Printf(attr_string,menu.hot_colour & 0x7f);
          Puts(menu.hot_colour > 0x7f ? BLINK : blank_str);
        }

        vbuf_flush();
      }

      entry=ENTRY_false;
      ch=Input_Char(CINPUT_display | CINPUT_noxlt | CINPUT_iread | 
                    (hotkeys(usr) ? CINPUT_dump : 0) |
                    (inmsgarea && (prm.flags2 & FLAG2_msgread) ?
                     CINPUT_msgread : 0),
                    NULL);
    }
    else
    {
      entry=ENTRY_false;

      while (1)
      {

Restart_Menu:

        option='\x00';

        /* Don't display menu if there are characters in linebuf, or if the
           help mode is HOTFLASH and there is a character waiting.  */

        if (isnl(linebuf) && !(hotkeys(usr) && Mdm_keyp() && Mdm_kpeek() != '\x00' && Mdm_kpeek() != '\x08'))
        {
          skipped_topline=FALSE;

          if (menuhelp==HOTFLASH)
            TopLine(LINE_top);
          else Printf(YELLOW "%s:%c",strupr(menu.title ? menu.title : mname),
                      menuhelp==NOVICE ? '\n' : ' ');

          if (menuhelp==REGULAR)
            Puts("[" GRAY);

          break_loop=FALSE;

          first_item=TRUE;

          for (x=0,col=0;x < menu.num_options;x++)
          {
            if (brk_trapped || mdm_halt())
            {
              mdm_dump(DUMP_all);

              if (usr.help==HOTFLASH)
              {
                brk_trapped=0;

                realgoto=TRUE;
                Printf("%s" BLKONWHIT CLEOL,avt_home);
                realgoto=FALSE;

                x=col=0;  /* Start over */
              }
              else break;
            }

            /* hot-keys to the rescue! */
            if (hotkeys(usr) && Mdm_keyp() && Mdm_kpeek() != '\x00' &&
                Mdm_kpeek() != '\x08')
              break;

            if (menu.options[x]->type &&
                *menu.options[x]->name &&
                OptionOkay(menu.options[x],0,NULL))
            {
              /* Remove any brackets... */

              while (menu.options[x]->name[1]==')')
                memmove(menu.options[x]->name+1,menu.options[x]->name+2,
                        strlen(menu.options[x]->name+2)+1);

              /* Make sure there is ONE bracket exactly if we don't have   *
               * graphics.                                                 */

              if (graph==GRAPHICS_none)
              {
                memmove(menu.options[x]->name+2,menu.options[x]->name+1,
                        strlen(menu.options[x]->name+1)+1);

                menu.options[x]->name[1]=')';
              }

              switch (menuhelp)
              {
                default:
                  Printf(YELLOW "%c" GRAY "%-17.17s",menu.options[x]->name[0],
                         &menu.options[x]->name[1]);

                  col += 18;

                  if (col+20 >= usr.width)
                  {
                    col=0;
                    Putc('\n');
                  }
                  else
                  {
                    Puts("  ");
                    col += 2;
                  }
                  break;

                case REGULAR:
                  if (++col < usr.width-1 && !first_item)
                    Putc(' ');
                  else first_item=FALSE;

                  Putc(menu.options[x]->name[0]);

                  if (col >= usr.width-1)
                  {
                    Putc('\n');
                    first_item=TRUE;
                  }
                  break;

                case EXPERT:
                  break;

                case HOTFLASH:
                  getword(menu.options[x]->name,temp,cmd_delim,1);

                  if (current_col+strlen(temp) >= (usr.width-8))
                  {
                    /* The next forward/backward thingy is just to make sure that
                       the screen looks okay for mono. users, since red-on-white
                       appears as white-on-black for a mono user.               */

                    Puts(s(hfl_prmpt));

                    while (1)
                    {
                      keepflag=FALSE;

                      option=(char)Input_Char(CINPUT_noxlt | CINPUT_noctrlc |
                                 CINPUT_iread | 
                                  (inmsgarea && (prm.flags2 & FLAG2_msgread) ?
                                 CINPUT_msgread : 0),
                                 NULL);

                      if (option=='\0' || option==' ')
                      {
                        /* Clear the top line */
                        realgoto=TRUE;
                        Printf("%s" BLKONWHIT CLEOL,avt_home);
                        realgoto=FALSE;

                        option=0;
                        x--;      /* We'll get the current option the next time we loop! */

                        break;
                      }
                      /* else if key isn't BS/DEL, proceed -- otherwise loop! */
                      else if (option != '\x08' && option != '\x7f')
                      {
                        break_loop=TRUE; /* User hit a key, get out */
                        break;
                      }
                    }
                  }
                  else Printf("%s  ",temp);
                  break;
              }
            }

            if (break_loop)
              break;
          }
        }
        /* We didn't display the menu, a key was already waiting! */
        else if (usr.help==HOTFLASH && Mdm_keyp() && Mdm_kpeek() != '\x00' &&
                 Mdm_kpeek() != '\x08')
          skipped_topline=TRUE;

        switch (menuhelp)
        {
          default:
            if (col != 0 && isnl(linebuf))
              Putc('\n');

            ch=Input_Char(CINPUT_display | CINPUT_prompt | CINPUT_noxlt |
                          CINPUT_iread | 
                          (inmsgarea && (prm.flags2 & FLAG2_msgread) ?
                           CINPUT_msgread : 0),
                          s(w_select_c));
            goto MenuSelect;

          case REGULAR:
          case EXPERT:
            if (!brk_trapped && isnl(linebuf))
              Puts(menuhelp==REGULAR ? YELLOW "]: " CYAN : CYAN);

            brk_trapped=0;

            sprintf(temp,YELLOW "%s: " CYAN,strupr(menu.title ? menu.title : mname));

            ch=Input_Char(CINPUT_display | CINPUT_prompt | CINPUT_p_ctrlc |
                          CINPUT_noxlt | CINPUT_iread |
                          (inmsgarea && (prm.flags2 & FLAG2_msgread) ?
                          CINPUT_msgread : 0),
                          temp);

            goto MenuSelect;

          case HOTFLASH:
            if (option==0)
            {
              while (1)
              {
                if (!Mdm_keyp() && isnl(linebuf))
                  Puts(WHITONWHIT " \x08" BLKONWHIT);

                keepflag=FALSE;

                option=(char)Input_Char(CINPUT_noxlt | CINPUT_iread |
                                (inmsgarea && (prm.flags2 & FLAG2_msgread) ?
                                CINPUT_msgread : 0),
                                NULL);

                /* If not BS or VT100/DEL */
                if (option != '\x08' && option != '\x09' && option != '\x7f')
                  break;
              }
            }

            /* Re-cycle, go through while(1) loop again and redisplay menu! */
            if (option=='\0' || option==' ')
              goto Restart_Menu;

            if (isnl(linebuf) && !skipped_topline)
              TopLine(LINE_restore);

            ch=option;
            goto MenuSelect;

        } /* end switch */
      } /* end while */
    } /* end if */



  MenuSelect:   /* Process the user's choice */

    if (keepflag)
    {
      ch=*linebuf;
      memmove(linebuf,linebuf+1,strlen(linebuf+1)+1);
      keepflag=FALSE;
    }

    ch=toupper(ch);

    if (ch=='.')
    {
      if (menuhelp != HOTFLASH)
        menuhelp=NOVICE;
    }
    else
    {
      if (ch=='\r' || ch=='\0')
        ch='|';

      do_what=DO_either;

      for (x=okay=0;x < menu.num_options;x++)
        if (ch==toupper(*menu.options[x]->name) &&
            OptionOkay(menu.options[x],1,&do_what))
        {
          if ((p=Run_Option(&menu,x,ch,msg,&ret_code,&do_what)) != NULL)
          {
            if (eqstri(p,e_quit))
            {
              ret=ABORT;
              goto BackToCaller;
            }
            else if (eqstri(p,e_save))
            {
              ret=SAVE;
              goto BackToCaller;
            }

            strcpy(mname,p);
            entry=ENTRY_true;
            goto MenuBegin;
          }

          Check_Dirty(&menu,iread);

          okay=TRUE;
        }

      if (!okay && ch != '|')
      {
        Printf(dontunderstand,ch);
        Clear_KBuffer();

        if (!menuinc)
          menuinc=TRUE;
        else
        {
          if (menuhelp != NOVICE && menuhelp != HOTFLASH)
            menuhelp += 2;

          menuinc=FALSE;
        }
      }
      else if (okay || ch=='|')
        menuhelp=usr.help;
    }
  }

#ifdef DMALLOC
  ptab();
#endif

  ret=NOTHING;

BackToCaller:

  if (menu.num_options)
  {
    Free_Menu(&menu);
    Initialize_Menu(&menu);
  }

  inmsgarea=s_inmsgarea;
  infilearea=s_infilearea;
  menuname=last_mn;

  return ret;
}


/* Run_Option() - The main calling routine which invokes ALL of the menu   *
 * options, no matter what or where they are.                              *
 *                                                                         *
 * This function really "sucks", so to speak.  I would have loved to use   *
 * a dispatch table to handle all of these functions, but indirect calls   *
 * don't get along very well with the Microsoft Overlay Manager.  If       *
 * someone DOES know how to make an indirect interoverlay call,            *
 * please drop me a note!                                                  */

static char * near pascal Run_Option(struct _menu *menu,int opt,int ch,struct _msg *msg,int *ret_code,int *do_what)
{
  int usrpriv,
      x;

  if (! (menu->options[opt]->type==o_if ||
      (menu->options[opt]->flag & (OFLAG_then | OFLAG_else))))
  *ret_code=-1;

  if (msg)  /* If msg is non-NULL (ie. we're in an editor), then we        */
  {         /* can only perform the following options without screwing     */
            /* everything up.  If the SysOp adds an incorrect command,     */
            /* then the user will get a `You can't get there from here'    */
            /* message.                                                    */

    switch (menu->options[opt]->type)
    {
      case display_file:
      case xtern_dos:
      case xtern_run:
      case xtern_erlvl:
      case xtern_chain:
      case xtern_concur:
      case statistics:
      case o_yell:
      case o_cls:
      case userlist:
      case o_version:
      case edit_save:
      case edit_abort:
      case edit_list:
      case edit_edit:
      case edit_insert:
      case edit_delete:
      case edit_continue:
      case edit_to:
      case edit_from:
      case edit_subj:
      case edit_handling:
      case edit_quote:
      case read_diskfile:
        break;

      default:
        You_Cant_Get_There();
        return NULL;
    }
  }

  if (menu->options[opt]->kp_len)
  {
    if (strchr((byte *)(unsigned long)menu->options[opt]->keypoke,'%'))
      Parse_Outside_Cmd(Strip_Underscore((byte *)(unsigned long)menu->options[opt]->keypoke),&linebuf[strlen(linebuf)]);
    else strcat(linebuf,Strip_Underscore((byte *)(unsigned long)menu->options[opt]->keypoke));
  }

  switch (menu->options[opt]->type)
  {
    case nothing:
      break;

    case display_menu:
      if (! (menu->options[opt]->flag & OFLAG_nocls))
        Puts(CLS);

      if (inmsgarea || infilearea)
        Last_Other();

      Undo_Barricade();

      return (menu->arg[opt]);

    case display_file:
      *ret_code=Display_File(0,NULL,menu->arg[opt]);
      break;

    case xtern_erlvl:
      x=OUTSIDE_errorlevel;
      goto Outside_Cmd;

    case xtern_dos:
      x=OUTSIDE_dos;
      goto Outside_Cmd;

    case xtern_run:
      x=OUTSIDE_run;
      goto Outside_Cmd;

    case xtern_concur:
      x=OUTSIDE_concur;
      goto Outside_Cmd;

    case xtern_chain:
      x=OUTSIDE_chain;

    Outside_Cmd:
      *ret_code=Outside(PRM(out_leaving),PRM(out_return),
                        x | ((menu->options[opt]->flag & OFLAG_reread) ? OUTSIDE_reread : 0),
                        Strip_Underscore(menu->arg[opt]),
                        TRUE,
                        ((menu->options[opt]->flag & OFLAG_ctl) ? CTL_normal : CTL_none),
                        RESTART_menu,
                        menuname);

      Clear_KBuffer();
      entry=ENTRY_noheader;
      break;

    case o_cls:
      Puts(CLS);
      break;

    case goodbye:
      Last_Other();

      if (menu->num_options)
      {
        Free_Menu(menu);
        Initialize_Menu(menu);
      }

#ifdef DMALLOC
      ptab();
#endif

      Goodbye();

      entry=ENTRY_noheader;
      break;

    case statistics:
      Statistics();
      break;

    case o_yell:
      Yell();
      break;

    case userlist:
      *ret_code=UserList();
      break;

    case o_version:
      Version();
      break;

    case area_change:
      if (eqstri(menu->arg[opt],s(mnu_msg)))
      {
        Undo_Barricade();

        if (inmsgarea)
          Fix_Lastread();

        if (! Last_Msg())
          usrpriv=Msg_Area();

        Redo_Barricade(usrpriv);
      }
      else
      {
        Undo_Barricade();

        if (! Last_File())
          usrpriv=File_Area();

        Redo_Barricade(usrpriv);
      }
      break;

    case same_direction:
      if (! Last_Msg())
      {
        if (direction==DIRECTION_next)
          *ret_code=Msg_Next(last_msg);
        else *ret_code=Msg_Previous(last_msg);
      }
      break;

    case read_next:
      if (! Last_Msg())
        *ret_code=Msg_Next(last_msg);
      break;

    case read_previous:
      if (! Last_Msg())
        *ret_code=Msg_Previous(last_msg);
      break;

    case enter_message:
      if (! Last_Msg())
        *ret_code=Msg_Enter();
      break;

    case msg_reply:
      if (! Last_Msg())
        *ret_code=Msg_Reply();
      break;

    case read_nonstop:
      if (! Last_Msg())
        *ret_code=Msg_Nonstop();
      break;

    case read_original:
      if (! Last_Msg())
        *ret_code=Msg_Read_Original();
      break;

    case read_reply:
      if (! Last_Msg())
        *ret_code=Msg_Read_Reply();
      break;

    case msg_list:
      if (! Last_Msg())
        Msg_List(-1,0,0,NULL,FALSE,0);
      break;

    case msg_scan:
      if (! Last_Msg())
        Msg_Scan();
      break;

    case msg_checkmail:
      Msg_Checkmail();
      break;

    case msg_inquire:
      if (! Last_Msg())
        Msg_Inquire();
      break;

    case msg_kill:
      if (! Last_Msg())
        Msg_Kill(-1);
      break;

    case msg_hurl:
      if (! Last_Msg())
        Msg_Hurl();
      break;

    case forward:
      if (! Last_Msg())
        Msg_Forward();
      break;

    case msg_upload:
      if (! Last_Msg())
        Msg_Upload();
      break;

    case xport:
      if (! Last_Msg())
        Msg_Xport();
      break;

    case read_individual:
      if (! Last_Msg())
        *ret_code=Msg_Read_Individual(ch);
      break;

    case newfiles:
      *linebuf='*';
      *(linebuf+1)='\0';

      /* fall-through */

    case locate:
      if (! Last_File())
      {
        File_Locate();
        Header_File(ENTRY_nocheck);
        entry=ENTRY_false;
       }
      break;

    case file_titles:
      if (! Last_File())
        File_Titles();
      break;

    case type:
      if (! Last_File())
        File_Type();
      break;

    case upload:
      if (! Last_File())
        File_Upload(menuname);
      break;

    case download:
      if (! Last_File())
        File_Download(menuname);
      break;

    case raw:
      if (! Last_File())
        File_Raw();
      break;

    case file_kill:
      if (! Last_File())
        File_Kill();
      break;

    case contents:
      if (! Last_File())
        File_Contents();
      break;

    case file_hurl:
      if (! Last_File())
        File_Hurl();
      break;

    case chg_city:
      Chg_City();
      break;

    case chg_password:
      Chg_Password();
      break;

    case chg_help:
      Chg_Help();
      break;

    case chg_nulls:
      Chg_Nulls();
      break;

    case chg_width:
      Chg_Width();
      break;

    case chg_length:
      Chg_Length();
      break;

    case chg_tabs:
      Chg_Tabs();
      break;

    case chg_more:
      Chg_More();
      break;

    case chg_video:
      Chg_Graphics();
      break;

    case chg_editor:
      Chg_Edit();
      break;

    case chg_clear:
      Chg_Clear();
      break;

    case chg_ibm:
      Chg_Ibm();
      break;

    case chg_phone:
      Chg_Phone();
      break;

    case chg_realname:
      Chg_Realname();
      break;

    case edit_save:
      if (msg)
        return e_save;
      else break;

    case edit_abort:
      if (msg)
      {
        if (inmagnet)
          Puts(CLS);

        WhiteN();

        if (GetyNAnswer(abortmsg,0)==YES)
        {
          Free_All();
          return e_quit;
        }

        if (inmagnet)
          Fix_MagnEt();
      }
      break;

    case edit_list:
      if (msg)
        Bored_List(msg);
      break;

    case edit_edit:
      if (msg)
        Bored_Edit();
      break;

    case edit_insert:
      if (msg)
        Bored_Insert();
      break;

    case edit_delete:
      if (msg)
        Bored_Delete();
      break;

    case edit_continue:
      if (msg)
      {
        if (inmagnet)
          return e_save;
        else Bored_Continue();
      }
      break;

    case edit_to:
      if (msg)
        Bored_To(msg);
      break;

    case edit_from:
      if (msg)
        Bored_From(msg);
      break;

    case edit_subj:
      if (msg)
        Bored_Subject(msg);
      break;

    case edit_handling:
      if (inmagnet)
        Puts(CLS);

      if (msg)
        Bored_Handling(msg);
      break;

    case user_editor:
      User_Edit();
      Putc('\n');
      break;

    case override_path:
      if (! Last_File())
        File_Override_Path();
      break;

    case who_is_on:
      Who_Is_On();
      break;

    case read_diskfile:
      if (msg)
        Read_DiskFile();
      break;

    case edit_quote:
      if (msg)
        Bored_Quote();
      break;

    case leave_comment:
      Goodbye_Comment();
      break;

    case message:
      Last_Msg();
      break;

    case file:
      Last_File();
      break;

    case other:
      Last_Other();
      break;

    case o_press_enter:
      Puts(WHITE);
      Press_ENTER();
      break;

    case clear_stacked:
      *linebuf='\0';
      break;

    case key_poke:
      if (strchr(menu->arg[opt],'%'))
        Parse_Outside_Cmd(Strip_Underscore(menu->arg[opt]),&linebuf[strlen(linebuf)]);
      else strcat(linebuf,Strip_Underscore(menu->arg[opt]));
      break;

    case o_if:
      Process_If(menu,opt,ret_code,do_what);
      break;

    case o_menupath:
      strcpy(menupath,menu->arg[opt]);
      Add_Slash(menupath);
      *last_name='\0';
      break;

    case o_page:
      Page();
      break;

    case o_chat_cb:
      Chat(TRUE);
      break;

    case o_chat_pvt:
      Chat(FALSE);
      break;

    case chat_toggle:
      Chat_Toggle();
      break;

    case msg_change:
      Msg_Change();
      break;

    case chg_hotkeys:
      Chg_Hotkeys();
      break;
  }

  return NULL;
}


int pascal RiteArea(int areatype,int attrib)
{
  if ((attrib & SYSMAIL) && !(areatype & AREATYPE_matrix))
    return FALSE;

  if ((attrib & ECHOMAIL) && !(areatype & AREATYPE_echo))
    return FALSE;

  if (! ((attrib & ECHOMAIL) || (attrib & SYSMAIL)) && !(areatype & AREATYPE_local))
    return FALSE;

  return TRUE;
}



void pascal Free_Menu(struct _menu *menu)
{
  int x;

  if (menu->title)
    free(menu->title);

  if (menu->headfile)
    free(menu->headfile);

  if (menu->dspfile)
    free(menu->dspfile);

  for (x=0;x < menu->num_options;x++)
  {
    if (menu->options[x]->kp_len && menu->options[x]->keypoke)
      free((byte *)(unsigned long)menu->options[x]->keypoke);

    if (menu->options[x]->arglen && menu->arg[x])
      free(menu->arg[x]);

    free(menu->options[x]);
  }

  mknl(last_name);
}




void pascal Initialize_Menu(struct _menu *menu)
{
  int x;

  menu->header=HEADER_none;
  menu->num_options=0;
  menu->title_len=menu->dspfile_len=menu->headfile_len=0;
  menu->title=NULL;
  menu->dspfile=NULL;
  menu->headfile=NULL;

  for (x=0;x < NUM_MENU;x++)
    menu->options[x]=NULL;

  mknl(last_name);
}




int pascal Header_None(int entry)
{
  (void)entry;

  WhiteN();

  restart_system=FALSE;
  return TRUE;
}




int pascal Last_Other(void)
{
  if (inmsgarea && !in_mcheck)
    Fix_Lastread();

  FixMenuPath();
  Restore_Directories();

  sfree(msgs);

  inmsgarea=infilearea=FALSE;
  barricade_ok=FALSE;

  last=MENU_other;

  return 0;
}


int pascal UserHasMenuKeys(int usrkey,int menulock)
{
  int x;

  for (x=0;x < 8;x++)
    if (menulock & (1 << x))
      if (! (usrkey & (1 << x)))
        return FALSE;

  return TRUE;
}


int pascal MagnEtOkay(struct _opt *opt)
{
  if (inmagnet)
  {
    switch (opt->type)
    {
      case edit_save:
      case edit_abort:
      case edit_list:
      case edit_edit:
      case edit_insert:
      case edit_delete:
      case edit_quote:
      case display_file:
        return FALSE;
    }
  }

  return TRUE;
}



void pascal Undo_Barricade(void)
{
  if (locked2)
  {
    locked2=FALSE;
    usr.priv=lockpriv2;
    Find_Class_Number();
  }
}



void pascal Redo_Barricade(int usrpriv)
{
  if (usrpriv != usr.priv)
  {
    if (!locked2)
    {
      lockpriv2=usr.priv;
      locked2=TRUE;
    }

    usr.priv=usrpriv;
    Find_Class_Number();
  }
}


int pascal OverridePrivOkay(struct _opt *opt)
{
  int x;

  if (inmsgarea)
    for (x=0;x < MAX_OVR;x++)
      if (toupper(area.movr[x].ch)==toupper(opt->name[0]))
        return Check_Priv(area.movr[x].priv,area.movr[x].lock);

  if (infilearea)
    for (x=0;x < MAX_OVR;x++)
      if (toupper(area.fovr[x].ch)==toupper(opt->name[0]))
        return Check_Priv(area.fovr[x].priv,area.fovr[x].lock);

  return (Check_Priv(opt->priv,opt->lock));
}

int pascal Check_Priv(int priv,int lock)
{
  if (! GEPriv(usr.priv,priv))
    return FALSE;

  if (! UserHasMenuKeys(usr.key,lock))
    return FALSE;

  return TRUE;
}


int pascal OptionOkay(struct _opt *opt,int run_opt,int *do_what)
{
  if (OverridePrivOkay(opt) &&
      RiteArea(opt->areatype,area.attrib[class]) &&
      MagnEtOkay(opt) &&
      (local ? !(opt->flag & OFLAG_uremote) : !(opt->flag & OFLAG_ulocal)))
  {
    if (!run_opt)   /* If we're displaying a menu */
    {
      /* Don't display any NoDsp options */
      if (opt->flag & OFLAG_nodsp)
        return FALSE;

      /* And display everything else, without worrying about THEN/ELSE junk */

      return TRUE;
    }

    if (! do_what)
      return TRUE;


    if (*do_what==DO_then && !(opt->flag & OFLAG_then))
      return FALSE;
    else if (*do_what==DO_else && !(opt->flag & OFLAG_else))
      return FALSE;

    return TRUE;
  }
  else return FALSE;
}


void pascal Check_Dirty(struct _menu *menu,char *ir)
{
  if (menuname)
  {
    Convert_Star_To_Task(menuname);

    if (! eqstri(last_name,menuname))   /* Go fetch the menu from disk! */
    {
      Read_Menu(menu,menuname,ir);
      strcpy(last_name,menuname);
    }
  }
}


static void near Process_If(struct _menu *menu,int opt,int *ret_code,int *do_what)
{
  int var,
      action,
      cnst;

  char *p;

  if (menu->arg[opt])
  {
    p=menu->arg[opt];

    switch (*p++)
    {
      case 'R':
        var=*ret_code;
        break;

      default:
        return;
    }

    while (*p==' ')
      p++;

    switch (*p++)
    {
      case '=':
        action=ACTION_eq;
        break;

      case '>':
        if (*(p+1)=='=')
          action=ACTION_ge,p++;
        else action=ACTION_gt;
        break;

      case '<':
        if (*(p+1)=='=')
          action=ACTION_le,p++;
        else action=ACTION_lt;
        break;

      case '!':
        action=ACTION_ne;
        break;

      default:
        return;
    }

    cnst=atoi(p);

    switch (action)
    {
      case ACTION_eq:
        if (var==cnst)
          *do_what=DO_then;
        else *do_what=DO_else;
        break;

      case ACTION_ne:
        if (var != cnst)
          *do_what=DO_then;
        else *do_what=DO_else;
        break;

      case ACTION_lt:
        if (var < cnst)
          *do_what=DO_then;
        else *do_what=DO_else;
        break;

      case ACTION_le:
        if (var <= cnst)
          *do_what=DO_then;
        else *do_what=DO_else;
        break;

      case ACTION_gt:
        if (var > cnst)
          *do_what=DO_then;
        else *do_what=DO_else;
        break;

      case ACTION_ge:
        if (var >= cnst)
          *do_what=DO_then;
        else *do_what=DO_else;
        break;
    }

    return;
  }
}


void pascal FixMenuPath(void)
{
  if (*fix_menupath)
  {
    if (menuname)
      strcpy(menuname,fix_menupath);

    *fix_menupath='\0';
    *last_name='\0';
  }
}


int pascal BbsRunOpt(int opt_num,char *arg)
{
  struct _menu *menu;
  struct _opt *opt;
  
  int ret_code;
  
  if ((menu=malloc(sizeof(struct _menu)))==NULL)
    return -1;
  
  memset(menu,'\0',sizeof(struct _menu));
  
  menu->header=HEADER_none;
  menu->num_options=1;
  menu->menu_length=0;
  menu->hot_colour=-1;

  menu->title_len=0;
  menu->title=blank_str;

  menu->headfile_len=0;
  menu->headfile=blank_str;
  
  menu->dspfile_len=0;
  menu->dspfile=blank_str;
  
  menu->arg[0]=arg;

  if ((opt=menu->options[0]=malloc(sizeof(struct _opt)))==NULL)
  {
    free(menu);
    return -1;
  }

  opt->type=opt_num;
  opt->arglen=(arg ? strlen(arg) : 0);
  opt->priv=usr.priv;
  opt->areatype=AREATYPE_all;
  opt->lock=(byte)usr.key;
  opt->flag=0;
  opt->keypoke=(char far *)NULL;
  opt->kp_len=0;
  
  Run_Option(menu,0,arg ? *arg : 0,NULL,&ret_code,DO_either);
  
  free(menu->options[0]);
  free(menu);

  return ret_code;
}

